<?

// enable or disable the runtime feature (1 = ON | 0 = OFF)
$runtime_enabled = 1;

// failure tracking variable (leave at 0)
$fail = 0;

function runtime_approval($runtime) {
        global $fail, $runtime_enabled;

        if ($runtime_enabled != 1) exit;

        include "./conf.php";

        @mysql_connect("$aanvaldbhost", "$aanvaldbuser", "$aanvaldbpass") or die("<p>Fatal Error: Could not connect to database! Check conf.php");
        @mysql_select_db($aanvaldb) or die("Error - DBConnection Failure ($aanvaldb) Check conf.php for correct values");

        if (!file_exists("./tmp/install.cert") || $runtime == 1) {

                echo "<style>TD { COLOR:#000000; font-family:tahoma; font-size:11px;} A { COLOR:#000055; font-family:tahoma; font-size:11px;
                        text-decoration:none;} A:hover{ COLOR:#000055; font-family:tahoma; font-size:11px; text-decoration:underline;} </style>";

                echo "<table border=0 width=70%><tr><td>
                        <font color=#777777><h3>OpenAanval</h3><br>Intrusion Detection System (Runtime Installation and Verification System)</font><br>
			<hr size=1 color=#777777>";

                // Tests
                echo "<b>Directory & File Tests</b><br>The following tests verify the existance of files and directory structures which are required
			for correct operation. Should any of the following tests fail, please re-install your system.<br>";

                echo "<br>[Exists]";
                ra_file_test("./conf.php");
                ra_file_test("./tmp");
                ra_file_test("./modules");
                ra_file_test("./version");
                ra_file_test("./bulletin");
                ra_file_test("./poll");
                ra_file_test("./poll/monitor_poll.php");
                ra_file_test("./apps");
                ra_file_test("./apps/idsBackground.pl");
                ra_file_test("./sounds");
                ra_file_test("./syslog");
                ra_file_test("./images");

                echo "<br>[Writable]";
                ra_write_test("./tmp");
                ra_write_test("./syslog");

                if (file_exists("./conf.php")) {
                        echo "<p><b>Database & Table Tests</b><br>The following tests verify the existance of required system databases and tables. This system will attempt to create any missing tables should they not be found.<br>";

                        echo "<br>[OpenAanval Tables]";
                        ra_db_test("idsAction", 1);
                        ra_db_test("idsUsers", 1);
                        ra_db_test("idsTimezones", 1);
                        ra_db_test("idsHostnames", 1);
                        ra_db_test("idsFrequentOffenders", 1);
                        ra_db_test("idsTrack", 1);
                        ra_db_test("idsMain", 1);
                        ra_db_test("idsCollection", 1);
                        ra_db_test("idsSensor", 1);
                        ra_db_test("idsMark", 1);
                        ra_db_test("idsOps", 1);
                        ra_db_test("idsLogs", 1);
                        ra_db_test("idsOadBuffer", 1);
                        ra_db_test("idsModules", 1);
                        ra_db_test("idsStatus", 1);

                }

                // write install.cert if all tests pass.
                if ($fail == 0) {
                        $epoch = date("U");
                        $fp = fopen ("./tmp/install.cert", "w");
                        if ($fp) {
                                fputs ($fp, "$epoch");
                                fclose($fp);
                        }
                        echo "<p><font color=green>Your installation appears to have been completed successfuly.</font> <a href='?'>Click here to continue</a> or refresh your browser window.<p>";
                        unlink("./tmp/update.cert");
                        exit;
                } else {
                        echo "<p><font color=red>One or more of the above tests has failed. This will prevent your system from operating correctly.</font>
                	        <p>Please see your installation documentation or the Aanval support forum for assistance.<p>";
                        exit;
                }

                echo "</td></tr></table>";
        } 
}

function ra_write_test($data) {
        global $fail;

        echo "<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        if (is_writable("$data")) {
                echo "[<font color=green>pass</font>]";
        } else {
                echo "[<font color=red>fail</font>]";
                $fail = 1;
        }
        echo " $data";
}

function ra_file_test($data) {
        global $fail;

        echo "<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        if (file_exists("$data")) {
                echo "[<font color=green>pass</font>]";
        } else {
                echo "[<font color=red>fail</font>]";
                $fail = 1;
        }
        echo " $data";
}

function ra_process_test($data) {
        global $fail;

        echo "<br>TESTING: ";
        if (file_exists("$data")) {
                echo "[<font color=green>pass</font>] Processing (we think)";
        } else {
                echo "[<font color=orange>warning</font>] You will need to ensure your background PERL scripts are executing! Until they are
                        running and have finished their first initial run, you will NOT see any events within OpenAanval.";
        }
}

function ra_db_test($data, $type) {
        global $fail;

        echo "<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

        $query = @mysql_query("select * from $data limit 1");

        if ($query) {
                echo "[<font color=green>pass</font>]";
		$tmp_fail = 0;
        } else {
                echo "[<font color=red>fail</font>]";
                $fail = 1;
		$tmp_fail = 1;
        }

	if ($tmp_fail == 1 && $type == 1) {
                $tmp_msg = " [<font color=blue>Auto-Resolved: Table creation successfuly.</font> Refresh your browser!]";

		db_create_table("$data");
		$tmp = $tmp_msg;
	}

        echo " $data $tmp";
}

function ra_db_col_test($table, $col, $type, $len) {
	global $fail;

        $query = @mysql_query("select $col from $table limit 1");

        if (!$query) {
		$nquery = mysql_query("alter table $table add $col $type($len)");
		if (!$nquery) {
			$fail = 1;
			echo "[<font color=red>failure during alter table operation</font>]<br>";
		}
	}
}

function ra_db_rebuild($data, $type) {
        global $fail;

        echo "<br>UPDATE: ";

        $db_array = file("./db/$data.db");

        for ($i=0;$i<count($db_array);$i++) {

		if (strstr($db_array[$i], "INSERT")) {
			$temp_explode = explode("'", $db_array[$i]);
			$var = $temp_explode[1];

			$query = mysql_query("select var from $data where var = '$var'");
		        while (list($var) = mysql_fetch_row($query)) {
				$found = 1;
			}

			if (!$found) {
				mysql_query("$db_array[$i]");
				$msg .= ".";
				$update = 1;
			}
			unset($found);
		}
        }

        if ($update) {
                echo "[<font color=green>updated</font>]";
        } else {
                echo "[<font color=green>nothing to update</font>]";
        }

        echo " $data $msg ";
}

function db_create_table($table) {

        $db_array = file("./db/$table.db");

        for ($i=0;$i<count($db_array);$i++) {
                mysql_query("$db_array[$i]");
        }
}

?>
