<?

function prv_report_mgr() {
	global $login, $ops;

	echo "<table border=0 cellpadding=0 cellspacing=0 width=100%>";
	echo "<tr><td width=40% valign=top>";

		$data = "OpenAanval Report Manager<p>";

	        echo table1("95%", "center", "Report Manager", $data);

	echo "</td><td valign=top>";

		$data = "<br>Standard Report: ";
		$data .= "[<a href='javascript:openWin(\"?op=pub_report_view&type=0\")'>Today</a>] - ";
	        $data .= "[<a href='javascript:openWin(\"?op=pub_report_view&type=1\")'>1 Day</a>] - ";
	        $data .= "[<a href='javascript:openWin(\"?op=pub_report_view&type=2\")'>7 Day</a>] - ";
	        $data .= "[<a href='javascript:openWin(\"?op=pub_report_view&type=3\")'>30 Day</a>] - ";
                $data .= "[<a href='javascript:openWin(\"?op=pub_report_view&type=4\")'>6 Month</a>] - ";
                $data .= "[<a href='javascript:openWin(\"?op=pub_report_view&type=5\")'>12 Month</a>]<p>";

	        echo table1("95%", "center", "Reports", $data);

	echo "</td></tr></table>";

}

function report_header() {
	global $login, $ops;

	$date = date("U");

	$data = "<title>OpenAanval Generated Report</title>" . $ops->getOpsVar("site_page_style_a");
	$data .= "<table border=0 cellspacing=0 cellpadding=0 width=100%>
		<tr>
			<td valign=top width=80><img border=0 src='" . $ops->getOpsVar("img_mascot_b") . "'></td>
			<td valign=top>OpenAanval Report<br>Generated: " . timeDisplay(mainTimeConversion($date), 1) . "</td>
			<td valign=top align=right>
			<script language=\"JavaScript\"> if (window.print)
	                      document.write('<form><input type=\"button\" value=\"Print Report\" onClick=\"window.print()\"></form>');
		        </script>
			</td>
		</tr>
		</table><hr size=1>";
	$data .= "<table border=0 width=100% cellspacing=0 cellpadding=0><tr><td>";

	return $data;

}

function report_view() {
	global $login, $ops, $root_path;

        $type = getVar("type");

	$heading = report_header();
	$footing = report_footer();

	echo "$heading";
	
	if ($type == 0) {
		report_type_0();
	} else if ($type == 1) {
		report_type_1();
	} else if ($type == 2) {
		report_type_2();
	} else if ($type == 3) {
		report_type_3();
        } else if ($type == 4) {
                report_type_4();
        } else if ($type == 5) {
                report_type_5();
        }

	echo "$footing";
}

function reportTextA() {

	$conf .= "This document contains sensitive and / or confidential information, do not distribute, email, fax or transfer via any ";
	$conf .= "electronic mechanism without proper authorization. Information contained within this document should be handled with appropriate ";
	$conf .= "caution. While reasonable attempts have been made to confirm the accuracy of the data contained herein, ";
	$conf .= "Remote Assessment assumes no liability for the completeness, use of, or conclusions drawn from such data.";
	
	$obj .= "The objective of this report is to provide an accurate and detailed summary of the state of the current intrusion detection deployment. ";
	$obj .= "The following report information should be leveraged to strengthen existing information security policies and procedures, manufacture ";
	$obj .= "new policies and procedures and develop guidelines for future system and environment security deployments.";

	$summ .= "The following visual and numeric representations indicate the current state of security regarding the Aanval Intrusion ";
	$summ .= "Detection Console. These statistics are generated in real-time and reflect actual statistics as of the date / time of this ";
	$summ .= "report.";


	$data = "<br><b>Summary</b><br>$summ<p>
			<b>Objective</b><br>$obj<p>
			<b>Confidentiality</b><br>$conf<p>";

	return $data;
}

function sensorStats($t) {
	global $login;

        $da = "<img border=0 src='images/darrow.gif'>";

        $out .= "<table border=0 width=100% cellpadding=0 cellspacing=0 align=center>";
        $out .= "<tr bgcolor=#DDDDDD>
                <td>Sensor ID $da</td>
                <td>Sensor Name $da</td>
                <td>Sensor Location $da</td>
                <td>Timezone $da</td>
                <td>Sensor OS $da</td>
		<td>Total Events $da</td>";

        $objSensor = new mySensor();
        $sensorIDs = $objSensor->getSensorIDs(0);

        $eredir = base64_encode("?op=prv_moduleConfig&module=1");

        for ($i=0;$i<count($sensorIDs);$i++) {

                $objSensor = new mySensor();
                $objSensor->loadSensor($sensorIDs[$i]);

                $color2 = "#9999FF";
                $color3 = "#DDDDFF";
                $color4 = "#F3F3FF";
                $color5 = "#FAFAFF";

                if ($alt_number == 0) { $alt_bgcolor = "$color4"; $alt_number = 1; } else { $alt_bgcolor = "$color5"; $alt_number = 0; }

                $out .= "<tr bgcolor=$alt_bgcolor>
                        <td>" . $objSensor->getSensorVar("id") . "</td>
                        <td>" . $objSensor->getSensorVar("name") . "</td>
                        <td>" . $objSensor->getSensorVar("location") . "</td>
                        <td>" . timezone_display($objSensor->getSensorVar("timezone")) . "</td>
                        <td>" . $objSensor->getSensorVar("os") . "</td>
                        <td>" . totalEventsBySensor($t, $sensorIDs[$i]) . "</td>
                        </tr>";
        }

        $out .= "</table>";

	return $out;
}

function report_type_0() {
	global $login, $ops, $root_path;

        $total_sensors = total_sensors();
        $total_offenders = total_offenders("999");
        $total_offenders_today = total_offenders("0");
	$total_events = total_events("999");
        $total_events_today = total_events("0");
        $top_events_today = top_events("0");
        $top_offenders_today = top_offenders("0");

        if ($total_events_today != 0) $total_events_perc = $total_events_today/$total_events*100;
        if ($total_offenders_today != 0) $total_offenders_perc = $total_offenders_today/$total_offenders*100;

	$textOut = reportTextA();
	$sensorsOut = sensorStats(0);

        $data = "<table border=0 width=100% cellpadding=0 cellspacing=0>";
        $data .= "<tr><td width=140>Total Sensors:</td><td>$total_sensors</td></tr>";
        $data .= "<tr><td>Total Events:</td><td>" . red_meter1(100, 100)  . " $total_events<td></tr>";
        $data .= "<tr><td>Total Events Today:</td><td>" . red_meter1($total_events_perc, 100)  . " $total_events_today<td></tr>";
        $data .= "<tr><td>Total Offenders:</td><td>" . red_meter1(100, 100)  . " $total_offenders</td></tr>";
        $data .= "<tr><td>Total Offenders Today:</td><td>" . red_meter1($total_offenders_perc, 100)  . " $total_offenders_today</td></tr>";
        $data .= "</table>";

	echo table1("100%", "center", "Report Details", $textOut);

        echo table1("100%", "center", "Today's General Report Statistics", $data);

        echo table1("100%", "center", "Today's Sensor Statistics", $sensorsOut);

        echo table1("100%", "center", "Today's Top 20 Unique Events", $top_events_today);

        echo table1("100%", "center", "Today's Top 10 Offenders", $top_offenders_today);
}

function report_type_1() {
        global $login, $ops, $root_path;

        $total_sensors = total_sensors();
        $total_offenders = total_offenders("999");
        $total_offenders_day = total_offenders("1");
        $total_events = total_events("999");
        $total_events_day = total_events("1");
        $top_events_day = top_events("1");
        $top_offenders_day = top_offenders("1");

        if ($total_events_day != 0) $total_events_perc = $total_events_day/$total_events*100;
        if ($total_offenders_day != 0) $total_offenders_perc = $total_offenders_day/$total_offenders*100;

        $textOut = reportTextA();
        $sensorsOut = sensorStats(1);

        $data = "<table border=0 width=100% cellpadding=0 cellspacing=0>";
        $data .= "<tr><td width=140>Total Sensors:</td><td>$total_sensors</td></tr>";
        $data .= "<tr><td>Total Events:</td><td>" . red_meter1(100, 100)  . " $total_events<td></tr>";
        $data .= "<tr><td>Total Events (1 Day):</td><td>" . red_meter1($total_events_perc, 100)  . " $total_events_day (" . substr($total_events_perc, 0, 5) . "%)<td></tr>";
        $data .= "<tr><td>Total Offenders:</td><td>" . red_meter1(100, 100)  . " $total_offenders</td></tr>";
        $data .= "<tr><td>Total Offenders (1 Day):</td><td>" . red_meter1($total_offenders_perc, 100)  . " $total_offenders_day (" . substr($total_offenders_perc, 0, 5) . "%)</td></tr>";
        $data .= "</table>";

        echo table1("100%", "center", "Report Details", $textOut);

        echo table1("100%", "center", "1 Day General Report Statistics", $data);

        echo table1("100%", "center", "1 Day Sensor Statistics", $sensorsOut);

        echo table1("100%", "center", "1 Day Top 20 Unique Events", $top_events_day);

        echo table1("100%", "center", "1 Day Top 10 Offenders", $top_offenders_day);
}

function report_type_2() {
        global $login, $ops, $root_path;

        $total_sensors = total_sensors();
        $total_offenders = total_offenders("999");
        $total_offenders_week = total_offenders("7");
        $total_events = total_events("999");
        $total_events_week = total_events("7");
        $top_events_week = top_events("7");
        $top_offenders_week = top_offenders("7");

        if ($total_events_week != 0) $total_events_perc = $total_events_week/$total_events*100;
        if ($total_offenders_week != 0) $total_offenders_perc = $total_offenders_week/$total_offenders*100;

        $textOut = reportTextA();
        $sensorsOut = sensorStats(7);

        $data = "<table border=0 width=100% cellpadding=0 cellspacing=0>";
        $data .= "<tr><td width=140>Total Sensors:</td><td>$total_sensors</td></tr>";
        $data .= "<tr><td>Total Events:</td><td>" . red_meter1(100, 100)  . " $total_events<td></tr>";
        $data .= "<tr><td>Total Events (7 Day):</td><td>" . red_meter1($total_events_perc, 100)  . " $total_events_week<td></tr>";
        $data .= "<tr><td>Total Offenders:</td><td>" . red_meter1(100, 100)  . " $total_offenders</td></tr>";
        $data .= "<tr><td>Total Offenders (7 Day):</td><td>" . red_meter1($total_offenders_perc, 100)  . " $total_offenders_week</td></tr>";
        $data .= "</table>";

        echo table1("100%", "center", "Report Details", $textOut);

        echo table1("100%", "center", "7 Day General Report Statistics", $data);

        echo table1("100%", "center", "7 day Sensor Statistics", $sensorsOut);

        echo table1("100%", "center", "7 Day Top 20 Unique Events", $top_events_week);

        echo table1("100%", "center", "7 Day Top 10 Offenders", $top_offenders_week);
}

function report_type_3() {
        global $login, $ops, $root_path;

        $total_sensors = total_sensors();
        $total_offenders = total_offenders("999");
        $total_offenders_month = total_offenders("30");
        $total_events = total_events("999");
        $total_events_month = total_events("30");
        $top_events_month = top_events("30");
        $top_offenders_month = top_offenders("30");

        if ($total_events_month != 0) $total_events_perc = $total_events_month/$total_events*100;
        if ($total_offenders_month != 0) $total_offenders_perc = $total_offenders_month/$total_offenders*100;

        $textOut = reportTextA();
        $sensorsOut = sensorStats(30);

        $data = "<table border=0 width=100% cellpadding=0 cellspacing=0>";
        $data .= "<tr><td width=140>Total Sensors:</td><td>$total_sensors</td></tr>";
        $data .= "<tr><td>Total Events:</td><td>" . red_meter1(100, 100)  . " $total_events<td></tr>";
        $data .= "<tr><td>Total Events (30 Day):</td><td>" . red_meter1($total_events_perc, 100)  . " $total_events_month<td></tr>";
        $data .= "<tr><td>Total Offenders:</td><td>" . red_meter1(100, 100)  . " $total_offenders</td></tr>";
        $data .= "<tr><td>Total Offenders (30 Day):</td><td>" . red_meter1($total_offenders_perc, 100)  . " $total_offenders_month</td></tr>";
        $data .= "</table>";

        echo table1("100%", "center", "Report Details", $textOut);

        echo table1("100%", "center", "30 Day General Report Statistics", $data);

        echo table1("100%", "center", "30 Day Sensor Statistics", $sensorsOut);

        echo table1("100%", "center", "30 Day Top 20 Unique Events", $top_events_month);

        echo table1("100%", "center", "30 Day Top 10 Offenders", $top_offenders_month);
}

function report_type_4() {
        global $login, $ops, $root_path;

        $total_sensors = total_sensors();
        $total_offenders = total_offenders("999");
        $total_offenders_month = total_offenders("180");
        $total_events = total_events("999");
        $total_events_month = total_events("180");
        $top_events_month = top_events("180");
        $top_offenders_month = top_offenders("180");

        if ($total_events_month != 0) $total_events_perc = $total_events_month/$total_events*100;
        if ($total_offenders_month != 0) $total_offenders_perc = $total_offenders_month/$total_offenders*100;

        $textOut = reportTextA();
        $sensorsOut = sensorStats(180);

        $data = "<table border=0 width=100% cellpadding=0 cellspacing=0>";
        $data .= "<tr><td width=160>Total Sensors:</td><td>$total_sensors</td></tr>";
        $data .= "<tr><td>Total Events:</td><td>" . red_meter1(100, 100)  . " $total_events<td></tr>";
        $data .= "<tr><td>Total Events (6 Month):</td><td>" . red_meter1($total_events_perc, 100)  . " $total_events_month<td></tr>";
        $data .= "<tr><td>Total Offenders:</td><td>" . red_meter1(100, 100)  . " $total_offenders</td></tr>";
        $data .= "<tr><td>Total Offenders (6 Month):</td><td>" . red_meter1($total_offenders_perc, 100)  . " $total_offenders_month</td></tr>";
        $data .= "</table>";

        echo table1("100%", "center", "Report Details", $textOut);

        echo table1("100%", "center", "6 Month General Report Statistics", $data);

        echo table1("100%", "center", "6 Month Sensor Statistics", $sensorsOut);

        echo table1("100%", "center", "6 Month Top 20 Unique Events", $top_events_month);

        echo table1("100%", "center", "6 Month Top 10 Offenders", $top_offenders_month);
}

function report_type_5() {
        global $login, $ops, $root_path;

        $total_sensors = total_sensors();
        $total_offenders = total_offenders("999");
        $total_offenders_month = total_offenders("365");
        $total_events = total_events("999");
        $total_events_month = total_events("365");
        $top_events_month = top_events("365");
        $top_offenders_month = top_offenders("365");

        if ($total_events_month != 0) $total_events_perc = $total_events_month/$total_events*100;
        if ($total_offenders_month != 0) $total_offenders_perc = $total_offenders_month/$total_offenders*100;

        $textOut = reportTextA();
        $sensorsOut = sensorStats(365);

        $data = "<table border=0 width=100% cellpadding=0 cellspacing=0>";
        $data .= "<tr><td width=160>Total Sensors:</td><td>$total_sensors</td></tr>";
        $data .= "<tr><td>Total Events:</td><td>" . red_meter1(100, 100)  . " $total_events<td></tr>";
        $data .= "<tr><td>Total Events (12 Months):</td><td>" . red_meter1($total_events_perc, 100)  . " $total_events_month<td></tr>";
        $data .= "<tr><td>Total Offenders:</td><td>" . red_meter1(100, 100)  . " $total_offenders</td></tr>";
        $data .= "<tr><td>Total Offenders (12 Months):</td><td>" . red_meter1($total_offenders_perc, 100)  . " $total_offenders_month</td></tr>";
        $data .= "</table>";

        echo table1("100%", "center", "Report Details", $textOut);

        echo table1("100%", "center", "12 Month General Report Statistics", $data);

        echo table1("100%", "center", "12 Month Sensor Statistics", $sensorsOut);

        echo table1("100%", "center", "12 Month Top 20 Unique Events", $top_events_month);

        echo table1("100%", "center", "12 Month Top 10 Offenders", $top_offenders_month);
}

function report_footer() {

	
	$data = "<p><center>Generated by OpenAanval; Copyright 2002-2004 Remote Assessment</center>
		</td></tr></table>";

	return $data;
}

?>
