<?php

// MONITOR_POLL: Responsible for returning the correct monitor visual when auto-polling is enabled (default)

include "../conf.php";

// Tell the system we are in processor mode
$processor = 1;

// Load /modules/ directory recursively
recursiveModuleLoad();

// Get Primary Variables
$xdu = getVar("xdu");
$vis = getVar("vis");

// Simulate login to console
$login = new mySession("processor");
$login->setSessionVar("backgroundUser", $xdu);
$login->initSession($xdu, "");
$login->loadSession();

#echo $login->getSessionVar("id");

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

main($xdu, $vis);

function main($user, $vis) {

	header ("Content-type: text/javascript");
        $data = addslashes(eventMonitorDisplay($vis));
        echo "document.getElementById('pollEventMonitor').innerHTML='$data';";
	unset($data);

}

function loadSession($user) {

	$login = new mySession("processor");
	$login->setSessionVar("backgroundUser", $user);
	$login->initSession($user, "");
	$login->loadSession();

	return $login;
}

function recursiveModuleLoad() {
        global $root_path;

        # Read in all available modules recursively
        if (!$this_dir = @dir("$root_path/modules/")) {
                echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting.";
                exit;
        }
        while ($dir = $this_dir->read()) {
                if ($dir != "." && $dir != "..") {
                        if (substr($dir, -4, 4) == "_MOD") {
                                $this_sub = dir("$root_path/modules/$dir");
                                while ($file = $this_sub->read()) {
                                        if ($file != "." && $file != "..") {
                                                if (substr($file, 0,4) == "inc_") {
                                                        include "../modules/$dir/$file";
                                                }
                                        }
                                }
                        }
                }
        }
}

?>

